;
; open list of turkey pm10 station locations
;
openr,10,'turkey.pm10.stations.csv'
nstation=0l
readf,10,nstation
;
; now read blank header line
blank=''
readf,10,blank
lab_station=strarr(nstation)
reg_station=strarr(nstation)
lat_station=-999.+fltarr(nstation)
lon_station=-999.+fltarr(nstation)
alt_station=-999.+fltarr(nstation)
for ns=0,nstation-1 do begin
readf,10,blank
result=str_sep(blank,',')
lab_station(ns)=result(0)
reg_station(ns)=result(1)
;
; test for missing data
;
test1=float(result(2))
test2=float(result(2))
test3=float(result(2))
if test1 eq 0. or test2 eq 0. or test3 eq 0. then begin
print,'missing data for ',result(0),' ',result(1)
print,'lat=',test1,' lon=',test2,' alt=',test3
endif
if  test1 ne 0. and test2 ne 0. then begin
lat_station(ns)=float(result(2))
lon_station(ns)=float(result(3))
alt_station(ns)=float(result(4))
endif
endfor
;
; variables to extract from netcdf file
;
cname=[$
     'iq','ico','ich2o','inoy','ipan','o3vmr','ihno3t',$
     'cld6hr','cot6hr',$
     'iso2','iso4aer','idms','imsa',$
     'ibc1','ibc2','ioc1','ioc2',$
     'idu1','idu2','idu3','idu4','idu5',$
     'iss1','iss2','iss3','iss4','iss5'$
]
nchem=n_elements(cname)
; loop over the UW-Hybrid analysis files 
hybanal='uwhyb_station.fil'
close,1
openr,1,hybanal
nfiles=0
readf,1,nfiles
for m = 0, nfiles-1 do begin 
fdate=''
readf,1,fdate
;
; build label
;
yr='20'+strmid(fdate,0,2)
mn=strmid(fdate,2,2)
dy=strmid(fdate,4,2)
hr=strmid(fdate,24,2)
ifiles=fdate

   ifile=ifiles
   print,'processing columns for '+ifile
;
; build label
;
;
; build label
;
mn=strmid(ifile,13,2)
dy=strmid(ifile,16,2)
yr=strmid(ifile,19,4)
hr=strmid(ifile,24,3)
tlabel=hr+' '+yr+mn+dy
pslabel=yr+mn+dy+hr
print,' reading file ',ifile 
;
; read UW-Hybrid analysis data
;
idir='/archive/ARCPAC/UW-Hybrid/MLS50mb_OMI_MODIS_100ppmv_H2O_v7ems_Reanalysis_pfix_bro_ice_dzfix_newerrg/Netcdf/'
;
nc_file_id=ncdf_open(idir+ifile,/nowrite)
glob_info=ncdf_inquire(nc_file_id)

; get dimensions
;
for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
    if name eq 'lat' then nlat=dim
    if name eq 'lon' then nlon=dim
    if name eq 'lev' then nlev=dim
    if name eq 'theta' then ntheta=dim
endfor
if m eq 0 then begin
xindex=intarr(nstation)
yindex=intarr(nstation)
zst=fltarr(nstation,nfiles,nlev)
pst=fltarr(nstation,nfiles,nlev)
vst=fltarr(nstation,nfiles,nlev,nchem)
aodst=fltarr(nstation,nfiles)
endif
alat=dblarr(nlat)
alon=dblarr(nlon)
alev=dblarr(nlev)
atheta=dblarr(ntheta)
ncdf_varget,nc_file_id,'lat',lat
ncdf_varget,nc_file_id,'lon',lon
ncdf_varget,nc_file_id,'lev',lev
;
for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
endfor
nchem=n_elements(cname)
ncdf_varget,nc_file_id,'psfc',psfc
ncdf_varget,nc_file_id,'zsfc',zsfc
ncdf_varget,nc_file_id,'pdash',pdash
ncdf_varget, nc_file_id,'ttheta',th
ncdf_varget,nc_file_id,'geop',zdash
ncdf_varget,nc_file_id,'aod',aod

press=pdash
t=0.*press
   for l=1,nlev-1 do begin
      pl=reform(press(*,*,l),nlon,nlat)
      t(*,*,l)=reform(th(*,*,l),nlon,nlat)*(pl/1000.)^.286
   endfor
   R=287.05
   rhu=100.*press/(R*t)
;
; map chemical variables to 3d array one at a time
;
    d4d=fltarr(nlon,nlat,nlev,nchem)
;    dummy=fltarr(nlon,nlat,nlev)
    for k=0,nchem-1 do begin
      ncdf_varget,nc_file_id,cname(k),dummy
     if cname(k) eq 'iso4aer' then begin
; Convert volume mixing ratio (ppv) to mass concentration [kg/m3]
; Assume all sulfate is ammonium sulfate
   amo = 132.
   amd = 28.9644
   vmmr = amo/amd
   dummy=rhu*dummy*vmmr
endif
    if cname(k) eq 'ibc1' or cname(k) eq 'ibc2' or cname(k) eq 'ioc1' or cname(k) eq 'ioc2' then begin
; carbon aerosols
   amo = 16.8
   amd = 28.9644
   vmmr = amo/amd
   dummy=rhu*dummy*vmmr
endif
   if cname(k) eq 'idu1' or cname(k) eq 'idu2' or cname(k) eq 'idu3' or cname(k) eq 'idu4' then begin
; dust
   dummy=rhu*dummy
endif
   if cname(k) eq 'iss1' or cname(k) eq 'iss2' or cname(k) eq 'iss3' or cname(k) eq 'iss4' then begin
; ssalt
   dummy=rhu*dummy
endif

;      if k eq 0 then dummy=dummy*28.964/18.0153  ;mw dry air/mw h2o
      if cname(k) eq 'oxften' then begin
        ncdf_varget,nc_file_id,'oxdten',dummy2
        dummy = dummy-dummy2
        dummy2 = 0.
        ncdf_varget,nc_file_id,'o3dep',dummy2
        dummy(*,*,nlev-1) = dummy(*,*,nlev-1)+dummy2
        dummy2 = 0.
      endif
      d4d(*,*,*,k)=dummy
    endfor
;
; close netCDF file
;
ncdf_close,nc_file_id
for ns=0,nstation-1 do begin
if lon_station(ns) ne -999. and lat_station(ns) ne -999. then begin
xmin=min(abs(lon-lon_station(ns)))
ymin=min(abs(lat-lat_station(ns)))
xval=where(abs(lon-lon_station(ns)) eq xmin)
yval=where(abs(lat-lat_station(ns)) eq ymin)
xindex(ns)=xval(0)
yindex(ns)=yval(0)
zst(ns,m,*)=zdash(xindex(ns),yindex(ns),*)-zsfc(xindex(ns),yindex(ns))
pst(ns,m,*)=pdash(xindex(ns),yindex(ns),*)
aodst(ns,m)=aod(xindex(ns),yindex(ns))
for k=0,nchem-1 do begin
vst(ns,m,*,k)=d4d(xindex(ns),yindex(ns),*,k)
endfor
endif
endfor
endfor
close,10
;
; writeout data
;
for ns=0,nstation-1 do begin
if lon_station(ns) ne -999. and lat_station(ns) ne -999. then begin
   openw,2,lab_station(ns)+'.april.2008.dat'
printf,2,nfiles,nlev
z0=reform(zst(ns,*,*),nfiles,nlev)
p0=reform(pst(ns,*,*),nfiles,nlev)
v0=reform(vst(ns,*,*,*),nfiles,nlev,nchem)
aod0=reform(aodst(ns,*),nfiles)
printf,2,z0,p0
printf,2,nfiles,nlev,nchem
printf,2,v0
printf,2,nfiles
printf,2,aod0
close,2
endif
endfor
end
