;
; open list of turkey pm10 station locations
;
openr,10,'turkey.pm10.stations.csv'
nstation=0l
readf,10,nstation
;
; now read blank header line
blank=''
readf,10,blank
lab_station=strarr(nstation)
reg_station=strarr(nstation)
lat_station=-999.+fltarr(nstation)
lon_station=-999.+fltarr(nstation)
alt_station=-999.+fltarr(nstation)
for ns=0,nstation-1 do begin
readf,10,blank
result=str_sep(blank,',')
lab_station(ns)=result(0)
reg_station(ns)=result(1)
;
; test for missing data
;
test1=float(result(2))
test2=float(result(2))
test3=float(result(2))
if test1 eq 0. or test2 eq 0. or test3 eq 0. then begin
print,'missing data for ',result(0),' ',result(1)
print,'lat=',test1,' lon=',test2,' alt=',test3
endif
if  test1 ne 0. and test2 ne 0. then begin
lat_station(ns)=float(result(2))
lon_station(ns)=float(result(3))
alt_station(ns)=float(result(4))
endif
endfor
;
; variables to extract from netcdf file
;
cname=[$
     'iq','ico','ich2o','inoy','ipan','o3vmr','ihno3t',$
     'cld6hr','cot6hr',$
     'iso2','iso4aer','idms','imsa',$
     'ibc1','ibc2','ioc1','ioc2',$
     'idu1','idu2','idu3','idu4','idu5',$
     'iss1','iss2','iss3','iss4','iss5'$
]
;
; readin data
;
for ns=0,nstation-1 do begin
close,2
   openr,2,lab_station(ns)+'.april.2008.dat'
nfiles=0
nlev=0
nchem=0
readf,2,nfiles,nlev
z0=fltarr(nfiles,nlev)
p0=fltarr(nfiles,nlev)
readf,2,z0,p0
readf,2,nfiles,nlev,nchem
v0=fltarr(nfiles,nlev,nchem)
readf,2,v0
readf,2,nfiles
aod0=fltarr(nfiles)
readf,2,aod0



t=0*p0
jday=92.+.25*findgen(nfiles)
for l=0,nlev-1 do begin
t(*,l)=jday
endfor
;
; Specify window size
nxdim=1000L
nydim=800L
var=['dust']
units=['ug/m!u3!n']
scale=1.e9
for nv=0,0 do begin
title=var(nv)+' '+lab_station(ns)
p=p0
if var(nv) eq 'dust' then begin
index1=where(cname eq 'idu1')
data=v0(*,*,index1(0))
index2=where(cname eq 'idu2')
data=data+v0(*,*,index2(0))
index3=where(cname eq 'idu3')
data=data+v0(*,*,index3(0))
index4=where(cname eq 'idu4')
data=data+v0(*,*,index4(0))
endif
   lc=0
   set_plot,'ps'
   xsize=nxdim/100.
   ysize=nydim/100.
   !p.font=0
   device,/landscape,bits=8,filename='raqms_april_2008_'+var(nv)+'_'+lab_station(ns)+'.ps'
   device,/color
   device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
          xsize=xsize,ysize=ysize
   !p.thick=1.5                   ;Plotted lines twice as thick
   !p.charsize=1.
; set color table
loadct,39
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
erase
set_viewport,.2,.8,.2,.8
;plot_io,t,p,xrange=[92,122],yrange=[1000,.1],/nodata,$
plot,t,p,xrange=[92,122],yrange=[1000,0.],/nodata,$
 title=title,xtitle='Julian Day (2008)',ytitle='Pressure (mb)',/noeras
color=1+icmm2*findgen(31)/30.
data=data*scale
;index=where(p ge 0.)
index=where(p ge 400.)
level=min(data(index))+(max(data(index))-min(data(index)))*findgen(31)/30.
contour,data,t,p,/overplot,level=level,/cell_fill,c_color=color
!p.thick=1
; color bar
        !psym=0
        imin=min(level)
        imax=max(level)
        set_viewport,.2,.8,.125,.13
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle=units(nv),/noeras,xstyle=1,ystyle=5
        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(mcolor)
        for j=0,icmm1 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor
endfor
endfor
end
